procedure TMathSystem.FFT_in_Fp(var inputFactors, outputFactors: TInt32UArray;
                                const w,p: int32u);

//Modern Computer Algebra:
  //if p = r*2^s + 1, and a \in N a nonsquare modulo p
  //then you can use w = a^r mod p
var len: integer;
  procedure FFT_rek(start,step: integer);
  var i: integer;
      smove: integer;
      power_w_i:int32u;
  begin

    if start+step>=len then begin
      outputFactors[start]:=inputFactors[start];
      exit;
    end;

    smove:=len div step div 2;

    i:=start;
    power_w_i:=1;
    while (i<len-smove) do begin
      outputFactors[i]:=inputFactors[i];
      outputFactors[i+smove]:=inputFactors[i+smove];

      inputFactors[i]:=(outputFactors[i]+outputFactors[i+smove]) mod p;
      inputFactors[i+smove]:=(((outputFactors[i]-outputFactors[i+smove]) mod p)*power_w_i) mod p;

      power_w_i:=power_w_i*w mod p;

      inc(i,step);
    end;

    FFT_rek(start,step*2);
    FFT_rek(start+step,step*2);
  end;

var oldlen:integer;
    i:integer;
begin
    oldlen:=length(inputFactors);
    len:=0;
    for i:=30 downto 0 do
      if 1 shl i = oldlen then len:=i
      else if 1 shl i < oldlen then begin
        len:=i+1;
        break;
      end;
    len:=1 shl len;
    setlength(inputFactors,len);
    for i:=oldlen to len-1 do
      inputFactors[i]:=0;
    setlength(outputFactors,len);
    FFT_rek(0,1);
end;
