{$ifndef MATHOBJECT_INCFILE_INCLUDED}
uses mathObjects;
{$endif}

  function TMathSystem.add(a,b:PTerm): PTerm;
  var t:PTerm;
  begin
    {$ifdef debugTree}ShowMessage(printTerm(a)+' <+> '+printTerm(b)); {$endif}
    if (b^.typ=ttNumber64F) and (a^.typ<>ttNumber64F) then begin
      t:=a;a:=b;b:=t; //exchange
    end;
    if (a^.typ = ttNumber64F) and (b^.typ = ttNumber64F) then begin
      (PTermNumber64F(a))^.number:=(PTermNumber64F(a))^.number+(PTermNumber64F(b))^.number;
      Result:=a;
      FreeTerm(b);
    end else begin
      if a^.typ = ttNumber64F then
        if PTermNumber64F(a)^.number=0 then begin
          Result:=b;
          FreeTerm(a);
          exit;
        end;
      GetMem(result,sizeof(ttermBinOp));
      with PTermBinOp(result)^ do begin
        typ:=ttBinOp;
        op:='+';
        t1:=a;
        t2:=b;
      end;
    end;
  end;

  function TMathSystem.sub(a,b:pterm): PTerm;
  var t:PTerm;
  begin
    if (b^.typ=ttNumber64F) and (a^.typ<>ttNumber64F) then begin
      t:=a;a:=b;b:=t; //exchange
    end;

    if (a^.typ = ttNumber64F) and (b^.typ = ttNumber64F) then begin
      (PTermNumber64F(a))^.number:=(PTermNumber64F(a))^.number-(PTermNumber64F(b))^.number;
      Result:=a;
      FreeTerm(b);
      exit;
    end;

    if (b^.typ=ttNumber64F)and(PtermNumber64F(b)^.number=0) then begin
      result:=a;
      FreeTerm(b);
      exit;
    end;

    GetMem(result,sizeof(ttermBinOp));
    with PTermBinOp(result)^ do begin
      typ:=ttBinOp;
      op:='-';
      t1:=a;
      t2:=b;
    end;
  end;

  function TMathSystem.mul_simple(a,b:PTerm): PTerm;        //non-destructive
  begin
    GetMem(result,sizeof(ttermBinOp));
    with PTermBinOp(result)^ do begin
      typ:=ttBinOp;
//      ref:=1;
      op:='*';
      t1:=a;
      t2:=b;
    end;
  end;

  function TMathSystem.power_simple(a,b:PTerm): PTerm; //non-destructive
  begin
    GetMem(result,sizeof(ttermBinOp));
    with PTermBinOp(result)^ do begin
      typ:=ttBinOp;
//      ref:=1;
      op:='^';
      t1:=a;
      t2:=b;
    end;
  end;

  function TMathSystem.mul(a,b:PTerm): PTerm;
  var t:PTerm;
  begin
    {$ifdef debugTree}ShowMessage(printTerm(a)+' <*> '+printTerm(b)); {$endif}
    //Rein numerisch?
    if (b^.typ=ttNumber64F) and (a^.typ<>ttNumber64F) then begin
      t:=a;a:=b;b:=t; //exchange
    end;
    if (a^.typ=ttNumber64F) then begin
      if PTermNumber64F(a)^.number=0 then begin
        result:=a;
        freeterm(b);
        exit;
      end;
      if PTermNumber64F(a)^.number=1 then begin
        result:=b;
        freeterm(a);
        exit;
      end;
    end;

    GetMem(result,sizeof(ttermBinOp));
    with PTermBinOp(result)^ do begin
      typ:=ttBinOp;
      op:='*';
      t1:=a;
      t2:=b;
    end;
  end;

  //----------------------------------------------------------------------------
  //===========================  Divisionsfunktion =============================
  //----------------------------------------------------------------------------

  function TMathSystem.divide(a,b:PTerm): PTerm;
  var t:PTerm;
  begin
    {$ifdef debugTree}ShowMessage(printTerm(a)+' <*> '+printTerm(b)); {$endif}
    //Rein numerisch?
    if (b^.typ=ttNumber64F) and (a^.typ<>ttNumber64F) then begin
      t:=a;a:=b;b:=t; //exchange
    end;
    if (a^.typ=ttNumber64F) then begin
      if PTermNumber64F(a)^.number=0 then begin
        result:=a;
        freeterm(b);
        exit;
      end;
      if PTermNumber64F(a)^.number=1 then begin
        result:=b;
        freeterm(a);
        exit;
      end;
    end;

    GetMem(result,sizeof(ttermBinOp));
    with PTermBinOp(result)^ do begin
      typ:=ttBinOp;
      op:='/';
      t1:=a;
      t2:=b;
    end;
  end;

  function TMathSystem.power(a,b:PTerm): PTerm;
  begin
    if (a^.typ = ttNumber64F) and (b^.typ = ttNumber64F) then begin
      (PTermNumber64F(a))^.number:=math.power((PTermNumber64F(a))^.number,(PTermNumber64F(b))^.number);
      Result:=a;
      freemem(b);
    end else begin
      if (b^.typ = ttNumber64F) then
        if (PTermNumber64F(b)^.number=0) then begin
          Result:=b;
          PTermNumber64F(b)^.number:=1;
          FreeMem(a);
          exit;
        end else if (PTermNumber64F(b)^.number=1) then begin
          Result:=a;
          FreeMem(b);
          exit;
        end;
      GetMem(result,sizeof(ttermBinOp));
      with PTermBinOp(result)^ do begin
        typ:=ttBinOp;
//        ref:=1;
        op:='^';
        t1:=a;
        t2:=b;
      end;
    end;
  end;

  function TMathSystem.exp(t: PTerm): PTerm;
  begin
    if t^.typ=ttNumber64F then begin
      PTermNumber64F(t)^.number:=system.exp(PTermNumber64F(t)^.number);
      Result:=t;
    end else begin
      GetMem(result,sizeof(TTermFuncOp));
      with PTermFuncOp(result)^ do begin
        typ:=ttFuncOp;
        func:=foExp;
        param:=t;
      end;
    end;
  end;

  function TMathSystem.ln(t: PTerm): PTerm;
  begin
{    if (t^.typ=ttNumber64F)and(frac(system.ln(PTermNumber64F(t)^.number)=0) then begin
      PTermNumber64F(t)^.number:=system.ln(PTermNumber64F(t)^.number);
      Result:=t;
    end else }begin
      GetMem(result,sizeof(ttermFuncOp));
      with PTermFuncOp(result)^ do begin
        typ:=ttFuncOp;
//        ref:=1;
        func:=foLn;
        param:=t;
      end;
    end;
  end;
